Subject: Re: bug#51449: 28.0.50; iso-transl overwrites alt key bindings

From: Eli Zaretskii <[email-masked]>
Date: Thu, 28 Oct 2021 10:12:32 +0300

> Date: Wed, 27 Oct 2021 21:42:19 +0100
> From: "Mark Bestley" <[email-masked]>
> 
> In emacs -Q just need something to get the Alt key bound
> e.g.
> (setq  mac-command-modifier 'alt)
> 
> The when you Type A-c you get ¢ and you cannot bind it yourself.
> 
> On a mac I want the key by space to be Alt as that is what is printed on
> my PC keyboard. I suspect this is true with PCs
> 
> The issue is that (require 'iso-transl) is called before the user can alter its behaviour and that iso-transl.el
> then binds to various A-c and other keys.
> 
> This makes it impossible to use Alt as a modifier key
> 
> load-history shows
> 
> ("/Applications/MacPorts/Emacs.app/Contents/Resources/lisp/subdirs.el")
> ("/Applications/MacPorts/Emacs.app/Contents/Resources/site-lisp/subdirs.el")
> ("/Applications/MacPorts/Emacs.app/Contents/Resources/lisp/leim/leim-list.el")
> ("/Applications/MacPorts/Emacs.app/Contents/Resources/lisp/international/iso-transl.elc"
> iso-transl-dead-key-alist iso-transl-char-map iso-transl-language-alist iso-transl-ctl-x-8-map
>   (defun . iso-transl-define-keys)
>   (defun . iso-transl-set-language)
>   (provide . iso-transl))
> ("/Applications/MacPorts/Emacs.app/Contents/Resources/lisp/tooltip.elc"
>   (require . syntax)
>  
> In emacs 27 iso-transl was not called that early and only seem to be
> called by describe-bindings and so could be overridden as shown in Aquamacs

iso-transl is preloaded now.  But I don't think I understand why it
gets in your way: can't you unbind the bindings that iso-transl does,
if you have no use for them, or rebind them after changing Alt to be a
modifier key if you do have use for iso-transl?

(Caveat: I don't use a Mac, so I may be missing some Mac-specific
issue here.)